#!/usr/bin/env python
#   #----- MODIFY pseudo_code_dict BY -----------
#   #----- SUBSTITUTE FUNCTION IN TEXT FORM -----
#   #----- TO REAL pseudo_code ------------------
#   
#   ### THIS LINE IN THE TOP
#   from dttcmd import *
#
#   ### THESE LINES IN THE BOTTOM
#   self_func = []
#   for i in dir():
#       if callable(eval(i)): self_func.append(i)
#   
#   for i in pseudo_code_dict.keys():
#       p_list = pseudo_code_dict[i].sp_listit('\n')
#       for j in range(len(p_list)):
#           if '(' in p_list[j]:
#               if p_list[j].sp_listit('(',1)[0] in self_func:
#                   l = [n for n in range(len(p_list[j])) if p_list[j][n] == ')']
#                   t = p_list[j][:l[-1]+1]
#                   p_list[j] = p_list[j].rep_listace(t, eval(t))
#       pseudo_code_dict[i] = '\n'.join(p_list)
#   

from dttcmd import *

from header_WareeSans_Bold import *
#func_arg_list = [[2, 0], [1, 0], [3, 1], [1, 1], [4, 0], [0, 1], [0, 1], [0, 1], [3, 0], [3, 0], [2, 0], [1, 0], [1, 0], [4, 0], [3, 0], [5, 0], [2, 0], [2, 0], [2, 0], [3, 0], [0, 0]]
#
#cvt_dict = {
#    'evheight_lu' : 0,   #  -422
#    'tvheight_lu' : 0,   #  -422
#    'vbase' : 1,   #  0
#    'tvheight_num' : 2,   #  908
#    'evheight' : 3,   #  1062
#    'tvheight' : 4,   #  1140
#    'ecvheight' : 5,   #  1450
#    'tvheight_po' : 5,   #  1450
#    'estemtc' : 6,   #  218
#    'ecstemt' : 6,   #  218
#    'tstemtc' : 6,   #  218
#    'cvt_7' : 7,   #  130
#    'cvt_8' : 8,   #  139
#    'estemt' : 9,   #  207
#    'tstemt' : 9,   #  207
#    'estemw' : 10,   #  240
#    'tstemw' : 11,   #  240
#    'ecstemw' : 12,   #  253
#    'cvt_13' : 13,   #  233
#    'ecstemtc': 13,  #230
#    'cvt_14' : 14,   #  242
#    'cvt_15' : 15,   #  214
#    'cvt_16' : 16,   #  188
#    'sarastemw' : 16,   #  188
#    'stemwa' : 16,   #  188
#    'cvt_17' : 17,   #  216
#    'cvt_18' : 18,   #  210
#    'cvt_19' : 19,   #  175
#    'cvt_20' : 20,   #  177
#    'sarastemt':20,
#    'cvt_21' : 21,   #  231
#    'cvt_22' : 22,   #  113
#    'head_sara_stem' : 22,   #  113
#    'cvt_23' : 23,   #  133
##USER LAND
#    'tvheight_num_shoot' : 24,  # 908+24=932
#    'evheight_shoot' : 25,      # 1062+24=1086
#    'tvheight_shoot' : 26,      # 1140+24=1164
#    'ecvheight_shoot' : 27,     # 1450+27=1477
#    'headstem'  : 28,    # 140
#    'headdia'   : 29,    # 430
#    'headstemplushole' : 30,    # 290 
#    'estemwc'   : 31,   # 260
#    'ecstemwc'   : 32,   # 273
#    'vbase_shoot': 33,  #24
#    'tvbase_shoot': 33,  #24
#    'head_sara':    34, #360
#    }


#---GENERATE STEM FUNCTION---
#predefine delta string of stem (put before gen_cvt_func)
#ds_headstemplushole = "15-4 16-4 17-2 18-6 19-2 20+2 21-2 24+4 28+4 29+4 30+4 32-4 33+4 34+4 38+8 "
ds_headstemplushole = "14+4 19-2 20+4 21+4 25+4 30+4 31+4 34-4 35+4 36+4 40+4 "
ds_headstem = "9-4 "
ds_headdia = "14+8 "
ds_head_sara_stem = "9-4 10-4 "
ds_head_sara = ""
#DISABLE FOR BOLD
#ds_tstemtc = "9-1 10-1 11-1 12-1 13-1 14-1 15-1 16-1 "
#ds_tstemtc_thin = "9-2 10-2 11-2 12-2 13-2 14-2 15-2 16-2 "
#ds_tstemt = "9-1 10-1 11-1 12-1 13-1 14-1 15-1 16-1 "
#ds_tstemt_thin = "9-2 10-2 11-2 12-2 13-2 14-2 15-2 16-2 "

gen_cvt_func_dict = {
    #FOR UNROUNDED STEM
    #[min,black]
    #'mb':   ['estem*','tstem*','stem*','ecstem*'],
    #[min,rnd,black]
    #'mrb':  ['headstem*','head_sara_stem','head_sara'],
    #
    #FOR ROUNDED STEM
    #[min,rnd,black]
    'mrb':  ['estem*','tstem*','stem*','ecstem*','headstem*','head_sara_stem','head_sara','sarastem*','wanstem*','tnumstem*'],
    #[rp0,rnd,grey]
    '0rg':  ['headdia'],
    }

for arg,cvt_list in gen_cvt_func_dict.iteritems():
    new_list = []
    for i in cvt_list:
        if i[-1]=='*':
            c = i.strip('*')
            n = len(c)
            l = [x for x in cvt_dict.keys() if x[:n]==c]
            new_list.extend(l)
        else:
            new_list.append(i)
        
    for i in new_list:
        for j in ['1','1m','2','2m']:   #1=forward/bottomup, #2=reverse/topdown
            if j[-1] == 'm':    #m=move rp0
                cmd = 'mirp0'+arg
            else:
                cmd = 'mirp'+arg
            if j[0] == '1': #1=forward/bottomup, #2=reverse/topdown
                direction = '+'
            else:
                direction = '-'
            #AUTO GENERATE delta string
            try:
                exec "a = ds_%s " % (i,)
            except:
                exec "ds_%s = ''" % (i,)

            #GEN FUNC
            exec '''def %s_%s(s,direction="%s"):
    return %s("%s",s,ds_%s,direction)
''' % (i,j,direction,cmd,i,i,)

            #GEN EXTRA FUNC FOR THIN OF estemt, tstemt
            #USE IN UPPER STEM OF kho_khai, kho_kwai
            #***PREDEFINE: ds_estemt_thin
            if i in ['estemt','estemtc','tstemt','tstemtc']:
                #AUTO GENERATE delta string
                try:
                    exec "a = ds_%s_thin " % (i,)
                except:
                    #DEFAULT VALUE FOR 14,15,16 ppem
                    exec "ds_%s_thin = '14-2 15-2 16-2 '" % (i,)
                #GEN FUNC
                exec '''def %s_thin_%s(s,direction="%s"):
    return %s("%s",s,ds_%s_thin,direction)
''' % (i,j,direction,cmd,i,i,)


#EXAMPLE OF CVT FUNCTION DEFINED:
#
#def estemw_1(s): return """
#   MIRP[rnd,black]    estemw s
#   f_dstr(s,"ds_estemw")
#   """
#
#def estemw_2(s): return """
#   MIRP[rnd,black]    estemw s
#   f_dstr(s,"ds_estemw",direction="-")
#   """


#----------------------------------------
#DRY HEAD: KEEP HEAD OF CHARACTERS DRIED FOR 14,15,16 ppem
#ENABLE DRY HEAD FOR BOOK
#ds_dryhead = "14+3 15+3 16+3 "
#def dh1(*l): #dry head 
#    d = {}
#    for s in l:
#        if s-1 < 0 or s+1 < 0:
#            raise ValueError("ds value < 0: dh1(%s)" % (l,))
#        d[s-1] = ds_dryhead
#        d[s+1] = swap_dstr(ds_dryhead)
#    return f_dstr_dict(d)
##    return f_dstr_dict({
##        s-1: "15+4 16+3 17+3 18+3 ",
##        s+1: "15-4 16-3 17-3 18-3 " })
#
#def dh2(*l): #dry head
#    d = {}
#    for s in l:
#        if s-1 < 0 or s+1 < 0:
#            raise ValueError("ds value < 0: dh2(%s)" % (l,))
#        d[s-1] = swap_dstr(ds_dryhead)
#        d[s+1] = ds_dryhead
#    return f_dstr_dict(d)
##    return f_dstr_dict({
##        s-1: "15-4 16-3 17-3 18-3 ",
##        s+1: "15+4 16+3 17+3 18+3 " })
#
#def dh11(s): #dry 1 point +
#    return f_dstr(s,ds_dryhead)
#
#def dh12(s): #dry 1 point -
#    return f_dstr(s,ds_dryhead,direction='-')

#DISABLE DRY HEAD FOR BOLD
def dh1(*l):
    return ""
def dh2(*l):
    return ""
def dh11(s):
    return ""
def dh12(s):
    return ""


ds_ud = "11+2 12+3 13+4 14+4 15+4 16+4 "
def ud1(s): #universal dry +
    return f_dstr(s,ds_ud)

def ud2(s): #universal dry -
    return f_dstr(s,ds_ud,direction='-')

ds_udx = "11+2 12+3 13+4 14+4 15+4 16+4 17+8 18+8 19+8 20+8 21+8 22+8 "
def udx1(s): #universal dry +
    return f_dstr(s,ds_udx)

def udx2(s): #universal dry -
    return f_dstr(s,ds_udx,direction='-')

#================================================
def evbc1(s,li=[]):
    return pl(""
        , mirp0rg("evbase_shoot",s)
        , f_ip(li)
        )

def tvbc(s,li=[]):  #thai vbase curve
    return pl(""
        , mirp0rg("tvbase_shoot",s)
        , f_ip(li)
        )

def tvblu(s,li=[]):
    return pl(""
        , mirprg("tvheight_lu",s)
        , f_ip(li)
        )

def tvblum(s,li=[]):
    return pl(""
        , mirp0rg("tvheight_lu",s)
        , f_ip(li)
        )

def tvtc2(s,li=[]): #thai vtop curve
    return pl(""
        , mirp0rg("tvheight_shoot",s,"")
        , f_ip(li)
        )

def tvt2(s,li=[]):
    return pl(""
        #, 'SROUND 72', mirprg("tvheight",s), 'RTG'
        #, 'SROUND 73', mirprg("tvheight",s), 'RTG'
        #, 'SROUND 74', mirprg("tvheight",s), 'RTG'
        , 'SROUND 74', mirprg("tvheight",s,"9-8 31+8 "), 'RTG'
        , f_ip(li)
        )

def tvt2m(s,li=[]):
    return pl(""
        , mirp0rg("vheight",s,ds_vheight)
        , f_ip(li)
        )

def tvtpo(s,li=[]):
    return pl(""
        , mirprg("tvheight_po",s)
        , f_ip(li)
        )

def tvtpom(s,li=[]):
    return pl(""
        , mirp0rg("tvheight_po",s)
        , f_ip(li)
        )

def thbsara(s):
    return mdapr(s)

def tvtsara(s):
    return mdapr(s,"11+8 16+8 ")

def tvtwanayuk(s):
    return mdapr(s,"14-8 ")
    #return mdapr(s,"16+8 17+8 18+8 ")


def tvtn(s, li=[]):
    return pl(""
        , 'SROUND 73', mirp0rg("tvheight_num",s,"21+8 "), 'RTG'
        , f_ip(li)
        )

def tvtnc(s, li=[]):
    return pl(""
        , mirp0rg("tvheight_num_shoot",s)
        , f_ip(li)
        )
#==================================================

def head_0(s,li,direction="+",dia="headdia", dsh_extra=""):
    #round head
    s,add1 = gen_alignrp(s)
    i1,addi1 = gen_alignrp(li[0],2)
    i2,addi2 = gen_alignrp(li[1],2)
    l = li[2:]
    reverse_dir = direction.replace('+','*').replace('-','+').replace('*','-')
    if dia == "head_sara":
        ds_dia = ds_head_sara
        stem = "head_sara_stem"
        ds_stem = ds_head_sara_stem
    else:
        ds_dia = ds_headdia
        stem = "headstem"
        ds_stem = ds_headstem
    if l:
        addip = f_ip(l)
    else:
        addip = ""
    if dsh_extra:
        add1_extra = f_dstr(s,dsh_extra)
    else:
        add1_extra = ""
    return pl(""
        , 'SROUND 3'
        , mirpmrb(stem,i1,ds_stem,direction)
        , addi1
        , 'SROUND 69'
        , mirp0rg(dia,s,ds_dia,direction)
        , add1_extra
        , add1
        , addip
        , 'SROUND 3'
        , mirpmrb(stem,i2,ds_stem,reverse_dir)
        , addi2
        , 'RTG'
        )

def head1(s,li,dsh_extra=""):
    #left to right
    return head_0(s,li,direction="+",dsh_extra=dsh_extra)

def head2(s,li,dsh_extra=""):
    #right to left
    li = [li[1],li[0]] + li[2:]
    return head_0(s,li,direction="-",dsh_extra=dsh_extra)

def headsara1(s,li,dsh_extra=""):
    return head_0(s,li,direction="+",dia="head_sara",dsh_extra=dsh_extra)

def headsara2(s,li,dsh_extra=""):
    li = [li[1],li[0]] + li[2:]
    return head_0(s,li,direction="-",dia="head_sara",dsh_extra=dsh_extra)



def xhead0(s2,s3,direction="+"):
    s2,add2 = gen_alignrp(s2,2)
    s3,add3 = gen_alignrp(s3,2)
    return pl(""
        , 'SROUND 3'
        , headstem_1(s2,direction=direction)
        , add2
        , 'SROUND 5'
        , headstemplushole_1(s3,direction=direction)
        , add3
        , 'RTG'
        )


def xhead1(s1,s2,s3,dstr="14-8 15-8 16-8 ",direction="+"):
    s1,add1 = gen_alignrp(s1)
    return pl(""
        , 'SROUND 71'
        , mdrp0mrg(s1,dstr)
        , 'RTG'
        , add1
        , xhead0(s2,s3,direction)
        )

def xhead2(s1,s2,s3,dstr="9+8 35+8 ",direction="-"):
    s1,add1 = gen_alignrp(s1)
    return pl(""
        , 'SROUND 71'
        , mdrp0rg(s1,dstr)
        , 'RTG'
        , add1
        , xhead0(s2,s3,direction)
        )


#================================================
def v_notch_ko_kai(s1,s1s,s2):
    return pl(""
        , mdrp0rg(s1,"23+8 ")
        , alignrp(s1s)
        , stem_notch_1(s2)
        , dx(s2,-8)
        )

def v_head_kho_khai(s1,li1, s2, s3,s4, li4, add1=""):
    return pl(""
        , tvtc2(s1,li1)
        , add1
#book
#        , tstemt_thin_2(s2)
#        , mdrp0rg(s3,"14+8 15+8 16+8 ")
#        , head2(s4,li4)
#bold
        , tstemt_thin_2m(s2)
        , mdrprg(s3)
        , srp0(s1)
        , mdrp0rg(s4,"19+8 ")
        , xhead0(li4[0],li4[1])
        )

def v_head_kho_khuat(s1,s1s,li1, s2,s2s, s3,s4, s5,s6,li6 , add1=""):
    return pl(""
        , tvtc2(s1, li1+[s6])
        , alignrp(s1s)
        , add1
        , 'RTDG'
        , tstemt_2(s2)
        , shprp2(s2s)
        , 'RUTG'
        , mdrp0mrg(s3)
        , 'RTDG'
        , mdrprb(s4,"15+4 16+4 ")
        , 'RTG'
#book
#        , srp0(s1)
#        , mdrp0rg(s5)
#        , mdapr(s5,"14+8 15+8 16+8 ")
#        , head2(s6,li6)
#bold
        , mdapr(s6)
        , xhead0(li6[0],li6[1])
        , srp0(li6[1])
        , headstem_1(s5)
        )

def v_top_kho_khwai(s1,li1,s2, s3,s4,li4,add1=""):
    if len(li4) > 3:
        add4 = f_dstr_dict({
            li4[2]:"14+2 15+2 16+2 ",
            li4[3]:"14-4 15-4 16-4 ",
            })
    else:
        add4 = ""
    return pl(""
        , tvtc2(s1,li1)
        , add1
        , tstemtc_thin_2(s2)
#        , 'RUTG'
#        , mdrp0rw(s3)
#        , 'RTG'
#        , head2(s4,li4)
#        , add4
, mdapr(s4)
, add4
, head1(s3,li4)
        )

def v_top_kho_khon(s1,s1s,li1, s2,s2s, s3,s4, s5,s6,li6):
    if len(li6) > 3:
        add6 = f_dstr_dict({
            li6[2]:"14+2 15+2 16+2 ",
            li6[3]:"14-4 15-4 16-4 ",
            })
    else:
        add6 = ""
    return pl(""
        , tvtc2(s1,li1)
        , alignrp(s1s)
        , tstemtc_2(s2)
        , shprp2(s2s)
        , 'RUTG'
        , mdrp0rg(s3,"14+5 15+5 16-3 ")
        , 'RTG'
        , tstemt_2(s4)
        , mdrp0mrw(s5)
        , mdapr(s5)
        , head2(s6,li6)
        , add6
        , f_dstr_dict({s3:"14-3 15-4 ",s4:"16-3 "})
        )
        
def v_top_ro_rua(s1,li1, s2, s3,s4,s5,s6):
    return pl(""
        , tvtc2(s1,li1)
#        , tstemtc_thin_2(s2)
#        , 'RTDG'
#        , mdrp0rg(s3,"14+4 15+4 ")
#        , 'RTG'
, tstemtc_thin_2m(s2)
, 'RTDG',mdrp0rg(s3),'RTG'
        , tstemt_1(s4)
        , srp0(s1)
        , mdrp0g(s5)
        , tstemt_2(s6)
        )

#================================================
#new point reference
#f0,r0,...: use tuple to align multiple points

def trs_no_nu(r1,r2, h1,h2,li, r0):
    #thai rear stem of no nu
    return pl(""
        , mdapr(r0)
        , mdrp0mrw(h2,"10+8 11+8 ")
#book
#        , head2(h1,li)
#        , f_dstr(h2,"9+4 ")
##1#        , mdrp0rg(r1,"11-8 12-8 17-8 18-8 19-8 ")
##2#        , 'SROUND 73',ip_round(h1,h2,r1),'RTG'
##3#, 'SROUND 71', mdrp0rg(r1), 'RTG'
##4#, ip_round(h1,h2,r2), ip_round(h1,r2,r1), srp0(r1)
##        , tstemw_1(r2)
#        , ip_round(li[0],li[1],r2)
#        , tstemw_2(r1)
#bold
        , xhead0(li[1],li[0],direction='-')
        , ip_round(li[0],li[1],r2)
        , tstemw_2(r1)
        , shprp2(h1)
        , f_dstr(h2,"9+4 10-4 11-4 ")
        )

def trs_e(f1,f2, r1, r0):
    #sara e
    return pl(""
        , mdapr(r0)
        , mdrp0mrw(r1)
        , mdrp0rg(f1,"9-8 13+8 ")
        , tstemw_1(f2)
        )

#================================================
def tx2_0(f0, f1,f2, r1,r2, r0, fstem='tstemw',rstem='tstemw',fround=72,rround=71,dsf="",dsr=""):
    #thai x-direction walk for 2 stem: ko_kai,
    return uxrs2(f0, f1,fstem,f2, r1,rstem,r2, r0, fround=fround, rround=rround,dsf=dsf,dsr=dsr)


def tx2_1(f0, f1,f2,f3, f4,f5, r1,r2, r0, dsf=""):
    #thai x-direction walk for 2 stem: tho_thahan,
    fx4,temp = gen_alignrp(f4)
    return pl(""
        , tx2_0(f0, f4,f5, r1,r2, r0, fround=72, dsf=dsf)
        , srp0(fx4)
        , xhead1(f1,f2,f3)
        )

def tx2_2(f0, f1,f2, f3,f4,f5, r1,r2, r0, fround=72, dsf="",dsr=""):
    #thai x-direction walk for 2 stem: pho_phung
    fx1,temp = gen_alignrp(f1)
    return pl(""
        , tx2_0(f0, f1,f2, r1,r2, r0, fround=fround, dsf=dsf, dsr=dsr)
        , srp0(fx1)
        , xhead2(f3,f4,f5)
        )

def tx2_2p(f0, f1,f2, f3,f4,f5, r1,r2, r0, fround=72, dsf="",dsr=""):
    return tx2_2(f0, f1,f2, f3,f4,f5, r1,r2, r0, fround=fround, dsf=dsf,dsr=dsr)

def tx2_3(f0, f1,f2,li12, f3,f4, f5,f6, r1,r2, r0, dsh_extra="",i56=-1):
    #kho_khai
    fx0,temp = gen_alignrp(f0)
    f1,addf1 = gen_alignrp(f1)
    fx3,temp = gen_alignrp(f3)
    f5,addf5 = gen_alignrp(f5)
    f6,addf6 = gen_alignrp(f6,2)
    rx1,temp = gen_alignrp(r1)
    if i56 >= 0:
        addi56 = f_ip([i56])
    else:
        addi56 = ""
    return pl(""
        , tx2_0(f0, f3,f4, r1,r2, r0, fround=72,rround=71)
        , ip_round(f0,f3, f1)
        , addf1
        , head1(f2,li12,dsh_extra=dsh_extra)
        , 'SROUND 10'
        , ip_round(fx3,rx1,f5)
        , addf5
        , 'RTG'
        , mdrpg(f6)
        , addi56
        , addf6
        , f_dstr(f5,"14+2 15+2 16+2 ")
        )


def tx1(r1,r2, r0, rstem='tstemw',rround=71):
    #thai x-direction walk for 1 stem
    return uxrs1(r1,rstem,r2, r0, rround=rround)

def tx1_0(f0, f1, r1,r2, r0, rstem='tstemw', rround=71):
    #thai x-direction walk for 1 stem: ngo_ngu
    f0,addf0 = gen_alignrp(f0)
    f1,addf1 = gen_alignrp(f1)
    rx1,temp = gen_alignrp(r1)
    return pl(""
        , tx1(r1,r2, r0, rstem=rstem, rround=rround)
        , ip_round(f0,rx1, f1)
        )

def tx1_1(f0, f1,f2, r1, r0, fstem='tstemw', fround=72, rround=71):
    return uxrs1f(f0,f1,fstem,f2,r1,r0,fround,rround)



def tx3_0(f0, f1,f2, m1,m2, r1,r2, r0, fstem='tstemw',mstem='tstemw',rstem='tstemw',fround=72):
    #thai x-direction walk for 3 stem: cho_choe
    return uxrs3(f0, f1,fstem,f2, m1,mstem,m2, r1,rstem,r2, r0, fround=fround)

#================================================
def th_ko_kai(s1, s2,s3, s4,s5, s0=-1):
    if s0 >= 0:
#        ips0 = pl( ip_round(s0,s1, s2), srp0(s2) )
        ips0 = pl( srp0(s1), mdrp0rg(s2) )
    else:
#        ips0 = pl( srp0(s1), mdrp0rg(s2) )
        ips0 = pl( srp0(s1), mdrp0rg(s2) )
    return pl(""
        , 'SROUND 7', ips0, 'RTG'
        , mdrpg(s3)
#        , mirp0mrb('tstemw',s4,"12-2 13-2 14-3 15-3 16-2 ")
        , mdrp0rg(s4)
        , mdrpg(s5)
#        , udx2(s4)
        , ud1(s3)
        )

def th_kho_khwai(s1, s2,s3,i23, s4,s5,li45, s6):
    return pl(""
        , srp0(s1)
, mdrp0mrg(s2)
#, 'RTDG'
#        , mdrp0rg(s2,"14+4 15+4 16+4 ")
#, 'RTG'
        , tstemw_1(s3)
        , f_ip([i23])
#1#        , srp0(s6)
#1#        , mdrp0mrw(s5)
#1#        , head2(s5,li45)
#2#        , ip_round(s1,s6,s4)
#2#        , head1(s5,li45)
#3#        , srp0(s6)
#3#        , mdrpmrw(s5)
#3#        , ip_round(s1,s5,s4,"15-8 ")
#3#        , head1(s5,li45)
        , ip_round(s1,s6,s4,"15-8 ")
        , head1(s5,li45)
        )

#================================================
pseudo_code_dict = {

    'uni0E01':      #KO KAI
        packline(""
        , tx2_0(28, 15,13, 1,27, 29)
        , th_ko_kai(15, 20,19, 8,9, s0=28)
        , add_ip(20,27,[5,24])
        , ix()
        #y
        , sy()
        , mdap(1)
        , alignrp(14)
        , tvtc2(24,[16,19,20,21,8,9,10,13, 2,27])
        , tstemt_2(5)
        , iy()
        ),

    'uni0E02':    #KHO KHAI
        packline(""
        , tx2_3(53, 21,15,[50,44,12], 1,32, 7,27, 36,38, 54)
        , ud2(12)
        , ix()
        , dh2(18)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(33)
        , tvt2(38)
        , v_head_kho_khai(24,[2,32,4,29], 10, 12,18,[41,47])
        , iy()
        , dh2(15)
        ),

    'uni0E03':    #KHO KHUAT
        packline(""
        , tx2_3(56, 24,18,[53,47,13], 1,35, 7,30, 39,41, 57, dsh_extra="19-8 24-8 29-8 34-8 39-8 44-8 ")
        , add_ip(24,30, [26,27,28, 9,10,11])
        , ix()
        , dh1(15)
        , dh2(21)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(36)
        , tvt2(41)
        , v_head_kho_khuat(28,26,[2,35,4,32], 9,11, 10,27, 12,20,[44,50])
        , iy()
        , dh2(18)
        ),

    'uni0E04':    #KHO KHWAI
        packline(""
        , tx2_0(54, 35,8, 1,41, 55)
        , th_kho_khwai(35, 29,28,11, 14,20,[51,45,25], 1)
        , add_ip(35,41,[38,5])
        , ix()
        , dh1(17)
        , dh2(23)
        #y
        , sy()
        , mdap(1)
        , alignrp(28)
        , v_top_kho_khwai(38,[35,8,11,2,41],5, 17,23,[42,48,25,14])
        , ud2(11)
        , iy()
        , dh2(20)
        ),

    'uni0E05':    #KHO KHON
        packline(""
        , tx2_0(54, 35,8, 1,41, 55)
        , th_kho_khwai(35, 29,28,11, 14,20,[51,45,25], 1)
        , add_ip(35,41,[37,38,39,4,5,6])
        , ix()
        , dh1(17)
        , dh2(23)
        #y
        , sy()
        , mdap(1)
        , alignrp(28)
        , v_top_kho_khon(39,37,[35,8,30,11,2,41],4,6, 5,38, 17,23,[42,48,25,14])
        , ud2(11)
        , iy()
        , dh2(20)
        ),

    'uni0E06':    #KHO RAKHANG
        packline(""
        , tx2_3(78, 37,31,[63,57,26], 14,(48,3), 20,43, (51,1),53, 79, dsh_extra="")
        , add_ip(37,43,[39,40,41,22,23,24])
        , srp0(14)
        , xhead1(9,75,69)
        , ix()
        , dh1(28,12)
        , dh2(34,6)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(51)
        , tvt2(53)
        , v_head_kho_khuat(41,39,[15,48,17,45,20,43], 22,24, 23,40, 26,34,[54,60])
        , srp0(1)
        , tvbc(6)
        , head1(12,[66,72, 49,3])
        , ud1(3)
        , iy()
        , dh2(31)
        , dh1(9)
        ),

    'uni0E07':    #NGO NGU
        packline(""
        , tx1_0(38, 4, 11,23, 39)
        , add_ip(4,11,[5,1,8,9,0])
        , srp0(11)
        , xhead1(17,35,29)
        , ud2(8)
        , ix()
        , dh1(20)
        , dh2(12)
        #y
        , sy()
        , mdapr(1)
        , tstemnt_1(8)
        , tvtc2(20,[5])
        , head2(12,[26,32])
        , srp0(1)
        , mdapr(5)
        , mdrpg(4)
        , iy()
        , dh1(17)
        ),

    'uni0E08':    #CHO CHAN
        packline(""
        , tx2_0(48, 1,0, 20,33, 49)
        , ip_round(48,1,26)
        , ip_round(48,1,8)
        , srp0(8)
        , head1(14,[45,39,2])
        , add_ip(26,33,[30,23])
        , add_ip(1,0,[17])
        , ix()
        , dh1(11)
        , dh2(5)
        #y
        , sy()
        , mdap(1)
        , tstemtc_1(17)
        , tvtc2(30,[20,33,11])
        , tstemt_2(23)
        , mdapr(11)
        , mdrpmrw(26)
        , head2(5,[36,42])
        , iy()
        , dh1(8)
        ),

    'uni0E09':    #CHO CHING
        packline(""
        , trs_no_nu(16,30, 40,34,[63,57], 67)
        , iprs_front_stem(66, 1,'tstemw',(13,0), 30, fround=71)
        , xhead1(7,51,45)
        , ip_round(66,1,23)
        , add_ip(23,30,[27,20])
        , ix()
        , dh1(10)
        , dh2(4,37)
        #y
        , sy()
        , mdap(0)
        , tstemt_1(14)
        , tvtc2(27,[17,30,10])
        , tstemt_2(20)
        , mdapr(10)
        , mdrpmrw(23)
        , head2(2,[42,48])
        , srp0(0)
        , tvbc(37)
        , head1(16,[54,60,40,31])
        , iy()
        , dh1(7)
        , dh2(34)
        ),

    'uni0E0A':    #CHO CHANG
        packline(""
        , tx2_3(66, 21,15,[63,57,12], 1,32, 7,27, 36,51, 67)
        , add_ip(27,37,[40])
        , srp0(40)
        , mdrpg(48)
        , srp0(36)
        , mdrp0rg(44)
        , tstemw_1(45)
        , ud2(12)
        , ud2(48)
        , ix()
        , dh2(18)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(33)
        , v_head_kho_khai(24,[2,32,7,27,41,40,48,37,51], 10, 12,18,[54,60],
            add1=mdrpmrg(44))
        , iy()
        , dh2(15)
        ),

    'uni0E0B':    #SO SO
        packline(""
        , tx2_3(69, 24,18,[66,60,13], 1,35, 7,30, 39,54, 70, dsh_extra="19-8 24-8 29-8 34-8 39-8 44-8 ")
        , add_ip(24,30, [26,27,28,9,10,11])
        , add_ip(30,39,[43])
        , srp0(43)
        , mdrpg(51)
        , srp0(39)
        , mdrp0mrg(47)
        , tstemw_1(48)
        , dx(51,-8)
        , ix()
        , dh1(15)
        , dh2(21)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(36)
        , v_head_kho_khuat(28,26,[2,35,7,30,44,43,51,40,54], 9,11, 10,27, 13,21,[57,63],
            add1=mdrpmrg(47))
        , iy()
        , dh2(18)
        ),

    'uni0E0C':    #CHO_CHOE
        packline(""
#book
#        , tx3_0(81, 39,27, 15,51, (54,1),56, 82)
#        , srp0(39)
#        , xhead2(33,60,66)
#        , ip_round(15,51,72)
#        , srp0(72)
#        , mirp0rg('headstem',5)
#        , head2(11,[78,72])
#        , f_dstr(11,"9-4 ")
#bold
        , tx3_0(81, 39,27, 15,(51,3), (54,1),56, 82)
        , mdrp0rg(11)
        , xhead0(78,72)
        , srp0(39)
        , xhead2(33,60,66)
#
        , th_ko_kai(39, 44,43, 22,23, s0=81)
        #
        , add_ip(44,51,[48,19])
        , ix()
        , dh1(30)
        , dh2(36,8)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(54)
        , tvt2(56)
        , tvtc2(48,[40,43,44,45,22,23,27,27,16,51])
        , tstemt_2(19)
        , srp0(1)
        , tvbc(36)
        , alignrp(8)
        , head1((28,15),[(57,69),(63,75),52,3])
        , ud1(3)
        , iy()
        , dh1(11)
        , dh2(33)
        ),

    'uni0E0D.descless':    #YO YING
        packline(""
        , tx3_0(58, 25,13, 1,37, 41,43, 59)
        , srp0(25)
        , xhead2(19,49,55)
        , th_ko_kai(25, 30,29, 8,9, s0=58)
        #
        , add_ip(30,37,[34,5])
        , ix()
        , dh1(16)
        , dh2(22)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(38)
        , tvt2(43)
        , tvtc2(34,[26,29,30,31,8,9,10,13, 2,37])
        , tstemt_2(5)
        , srp0(1)
        , tvbc(22)
        , head1(14,[46,52])
        , iy()
        , dh2(19)
        ),

    'desc.uni0E0D':
        packline(""
        , thbsara(18)
        , mdrp0rg(6)
        , mdrprg(12)
        , f_ip([30,24])
        , ix()
        #y
        , sy()
        , mdap(33)
        , mdrp0mrw(9)
        , mdrprg(17)
        , mdrp0rg(3)
        , f_ip([27,21])
        , mdrp0rg(0)
        , sarastemt_1(14)
        , iy()
        ),

    'uni0E0E':    #DO CHADA
        packline(""
        , tx2_1(77, 37,64,58, 42,30, (18,1),54, 78)
        , th_ko_kai(42, 47,46, 25,26)
        , srp0(1)
        , mdrprg(69)
        , f_ip([13,16,3])
        , mdrp0rg(8,"17-8 ")
        , sarastemw_1(74)
        , add_ip(47,54,[51,22])
        , dx(69,8)
        , dx(16,-8)
        , ix()
        , dh1(40,11)
        , dh2(34,5)
        #y
        , sy()
        , mdap(77)
        , tvtc2(51,[43,46,47,48,25,26,27,30, 19,54])
        , tstemt_2(22)
        , srp0(77)
        , tvbc(34)
        , head1(42,[55,61])
        , srp0(77)
        , tvblum(5)
        , alignrp(1)
        , head1(11,[67,71, 13,69,3,16,18])
#
        , dx(3,8)
        , dx(13,-8)
        , iy()
        , dh1(37,8)
        ),

    'uni0E0F':    #TO PATAK
        packline(""
        , tx2_1(83, 43,70,64, 48,36, (24,1),60, 84)
        , th_ko_kai(48, 53,52, 31,32)
        , srp0(24)
        , mdrprg(75,"25+8 26+8 ")
        , f_ip([16,19,21,2,6])
        , mdrp0rg(11,"17-8 ")
        , sarastemw_1(80)
        , add_ip(53,60,[57,28])
        , dx(75,8)
        , dx(19,-8)
        , ix()
        , dh1(46,14)
        , dh2(40,8)
        #y
        , sy()
        , mdap(83)
        , tvtc2(57,[49,52,53,54, 31,32,33,36, 25,60])
        , tstemt_2(28)
        , srp0(83)
        , tvbc(40)
        , head1(48,[61,67])
        , srp0(83)
        , tvblum(8)
        , alignrp(4)
        , alignrp(1)
        , head1(14,[73,77, 16,19,75,6,21,22,2])
#
        , dx(6,8)
        , dx(16,-8)
        , iy()
        , dh1(43,11)
        ),

    'uni0E10.descless':    #THO THAN
        packline(""
        , tx2_0(63, 23,45, 20,48, 64)
        , ip_round(13,48,8)
        , srp0(8)
        , head1(14,[60,54,2])
        , ip_round(8,48,1)
        , srp0(1)
        , tstemw_1(0)
        , f_ip([17])
        , srp0(48)
        , mdrprw(35)
        , add_ip(23,35,[27,42])
        , ud2(45)
        , ix()
        , dh1(11)
        , dh2(5)
        #y
        , sy()
        , mdapr(1)
        , tstemtc_1(17)
        , v_top_ro_rua(27,[23,24,45,46,20,48], 42, 37,32,34,35)
        , srp0(46)
        , tstemt_2(22)
        , ip_round(22,1,11)
        , srp0(11)
        , head2(5,[51,57])
        , srp0(1)
        , iy()
        , dh1(8)
        ),

    'desc.uni0E10':
        packline(""
        , thbsara(39)
        , sarastemw_2(27)
        , mdrprg(33)
        , f_ip([49,43])
        , mdrp0rg(21)
        , f_ip([23,25,1,5,6])
        , mdrprg(13)
        , f_ip([59,54,18,8])
        , ix()
        #y
        , sy()
        , mdap(62)
        , mdrp0mrw(36)
        , mdrp0rg(30)
        , f_ip([40,46])
        , mdrp0rg(1)
        , alignrp(5)
        , alignrp(10)
        , sarastemt_1(27)
        , shprp2(23)
        , mdrprg(16)
        , f_ip([52,56])
        , iy()
        ),

   'uni0E11':    #THO NANGMONTHO
        packline(""
        , tx2_3(55, 32,26,[52,46,21], 9,8, 15,38, 1,41, 56, dsh_extra="19-8 24-8 29-8 34-8 39-8 44-8 ")
        , add_ip(32,38, [34,35,36, 17,18,19])
        , ix()
        , dh2(29)
        #y
        , sy()
        , mdap(1)
        , alignrp(8)
        , v_head_kho_khuat(36,34,[10,15,38,6,2,41], 17,19, 18,35, 21,29,[43,49], add1=pl( alignrp(40), tstemt_2(4)))
        , ud2(38)
        , iy()
        , dh2(26)
        ),

    'uni0E12':    #THO PHUTHAO
        packline(""
#book
#        , tx3_0(77, 41,19, 12,47, (50,1),52, 78)
#        , th_kho_khwai(41, 38,37,22, 27,33,[62,56,24], 12)
#        , ip_round(12,47,68)
#        , srp0(68)
#        , mirp0rg('headstem',3)
#        , head2(9,[74,68])
#bold
        , tx3_0(82, 46,19, 12,(52,3), (55,1),57, 83)
        , th_kho_khwai(46, 40,39,22, 27,33,[67,61,24], 12)
        , srp0(12)
        , mdrp0rg(9)
        , xhead0(79,73)
#
        , add_ip(46,52,[48,49,50,15,16,17])
        , ud1(24)
        , ix()
        , dh11(25)
        , dh1(30)
        , dh2(6)
        #y
        , sy()
        , mdap(1)
        , alignrp(39)
        , tstemt_1(55)
        , tvt2(57)
        , v_top_kho_khon(50,48,[22,46,19,13,52], 15,17, 16,49, 30,24,[58,64])
        , srp0(1)
        , tvbc(6)
        , head1(12,[70,76,53,3])
        , ud2(24)
        , ud1(3)
        , iy()
        , dh1(27,9)
        , dh2(33)
        ),

    'uni0E13':    #NO NEN
        packline(""
        , trs_no_nu(40,42, 52,46,[75,69], 79)
        , iprs_front_stem(78, 25,'tstemw',13, 40)
        , xhead2(19,57,63)
        , th_ko_kai(25,30,29,8,9,s0=78)
        , iprs_middle_stem(25, 1,'tstemw',(37,0), 40)
        , add_ip(30,37,[34,5])
        , ix()
        , dh1(16)
        , dh2(22,49)
        #y  
        , sy()
        , mdap(1)
        , tstemt_1(38)
        , tvt2(42)
        , tvtc2(34,[26,29,30,31, 8,9,10,13, 2,37])
        , tstemt_2(5)
        , srp0(1)
        , tvbc(22)
        , alignrp(49)
        , head1((14,40),[(54,66),(60,72),43,52])
        , ud1(52)
        , iy()
        , dh2(19,46)
        ),

    'uni0E14':    #DO DEK
        packline(""
        , tx2_0(54, 35,8, 1,41, 55)
        , th_kho_khwai(35, 29,28,11, 16,22,[51,45,13], 1)
        , add_ip(35,41,[38,5])
        , ud1(13)
        , ix()
        , dh11(14)
        , dh1(19)
        #y
        , sy()
        , mdap(1)
        , alignrp(28)
        , v_top_kho_khwai(38,[35,8,30,2,41,11],5,19,13,[42,48])
        , iy()
        , dh1(16)
        , dh2(22)
        ),

    'uni0E15':    #TO TAO
        packline(""
        , tx2_0(54, 35,8, 1,41, 55)
        , th_kho_khwai(35, 29,28,11, 16,22,[51,45,13], 1)
        , add_ip(35,41,[37,38,39,4,5,6])
        , ud1(13)
        , ix()
        , dh11(14)
        , dh1(19)
        #y
        , sy()
        , mdap(1)
        , alignrp(28)
        , v_top_kho_khon(39,37,[35,8,30,2,41,11],4,6,5,38,19,13,[42,48])
        , iy()
        , dh1(16)
        , dh2(22)
        ),

    'uni0E16':      #THO THUNG
        packline(""
        , tx2_2(50, 25,13, 19,41,47, 1,37, 51)
        , th_ko_kai(25, 30,29, 8,9, s0=50)
        , ix()
        , dh1(16)
        , dh2(22)
        #y
        , sy()
        , mdap(1)
        , tvtc2(34,[26,29,30,31,8,9,10,13, 2,37])
        , tstemt_2(5)
        , srp0(1)
        , tvbc(22)
        , head1(14,[38,44])
        , iy()
        , dh2(19)
        ),

    'uni0E17':      #THO THAHAN
        packline(""
        , tx2_1(41, 15,38,32, 9,(21,8), 1,28, 42)
        , add_ip(21,1,[6])
        , srp0(6)
        , mdrpg(24) 
        , ix()
        , dh1(18)
        , dh2(12)
        #y
        , sy()
        , mdap(1)
        , alignrp(8)
        , tvtc2(18,[22,24,8,2,28])
        , alignrp(26)
        , tstemt_2(4)
        , head2(10,[29,35])
        , ud2(22)
        , iy()
        , dh1(15)
        ),

    'uni0E18':      #THO THONG
        packline(""
        , tx2_0(39, 1,3, 7,36, 40)
        , 'RTDG'
        , ip_round(39,1,11)
        , tstemtc_1(33)
        , 'RTG'
        , srp0(40)
        , mdrpmrw(23)
        , add_ip(11,23,[15,30,20,25])
        , ud2(33)
        , ix()
        #y
        , sy()
        , mdap(1)
        , tstemt_1(4)
        , v_top_ro_rua(15,[2,11,12,33,34,8,36], 30, 25,20, 22,23)
        , srp0(34)
        , tstemt_2(10)
        , iy()
        ),

    'uni0E19':      #NO NU
        packline(""
        , trs_no_nu(16,18, 28,22,[51,45], 55)
        , iprs_front_stem(54, 1,'tstemw',(13,0), 16, fround=71, dsf="13-8 ")
        , xhead1(7,39,33)
        , ix()
        , dh1(10)
        , dh2(25,4)
        #y
        , sy()
        , mdap(0)
        , tstemt_1(14)
        , tvt2(18)
        , tvtc2(10)
        , head2(2,[30,36])
        , srp0(0)
        , tvbc(25)
        , head1(19,[42,48,28,16])
        , ud1(28)
        , iy()
        , dh1(7)
        , dh2(22)
        ),  

    'uni0E1A':      #BO BAIMAI
        packline(""
        , tx2_1(34, 7,31,25, 1,13, 17,19, 35)
        , ix()
        , dh1(10)
        , dh2(4)
        #y  
        , sy()
        , mdap(1)
        , tstemt_1(14)
        , tvt2(19)
        , tvtc2(10)
        , head2(2,[22,28])
        , iy()
        , dh1(7)
        ),

    'uni0E1B':      #PO PLA
        packline(""
        , tx2_1(34, 7,31,25, 1,13, 17,19, 35)
        , ix()
        , dh1(10)
        , dh2(4)
        #y  
        , sy()
        , mdap(1) 
        , tstemt_1(14)
        , tvtpo(19)
        , tvtc2(10)
        , head2(2,[22,28])
        , iy()
        , dh1(7)
        ),

    'uni0E1C':      #PHO PHUNG
        packline(""
        , tx2_2p(35, 4,16, 11,26,32, 20,22, 36)
        , add_ip(16,20,[3,2,1])
        , srp0(2)
        , mdrpg(18)
        , mdrpg(19)
        , ix()
        , dh1(8)
        , dh2(14)
        #y  
        , sy()
        , mdap(1)
        , alignrp(3)
        , tvt2(22)
        , tvtc2(8,[17])
        , head2(16,[23,29])
        , add_ip(16,1,[18,2])
        , ud1(2)
        , ud2(17)
        , srp0(17)
        , alignrp(20)
        , iy()
        , dh2(11)
        ),  

    'uni0E1D':      #FO FA
        packline(""
        , tx2_2p(35, 4,16, 11,26,32, 20,22, 36)
        , add_ip(16,20,[3,2,1])
        , srp0(2)
        , mdrpg(18)
        , mdrpg(19)
        , ix()
        , dh1(8)
        , dh2(14)
        #y  
        , sy()
        , mdap(1)
        , alignrp(3)
        , tvtpo(22)
        , tvtc2(8,[17])
        , head2(16,[23,29])
        , add_ip(16,1,[18,2])
        , ud1(2)
        , ud2(17)
        , srp0(17)
        , alignrp(20)
        , iy()
        , dh2(11)
        ),  

    'uni0E1E':      #PHO PHAN
        packline(""
        , tx2_1(35, 10,32,26, 4,(16,3), (20,1),22, 36)
        , add_ip(16,20,[2])
        , srp0(2)
        , mdrpg(18)
        , mdrpg(19)
        , ix()
        , dh1(13)
        , dh2(7)
        #y
        , sy()
        , mdap(1)
        , alignrp(3)
        , tvt2(22)
        , tvtc2(13,[2,17,18,19])
        , head2(5,[23,29])
        , ud1(2)
        , ud2(17)
        , srp0(17)
        , alignrp(20)
        , iy()
        , dh1(10)
        ),

    'uni0E1F':      #FO FAN
        packline(""
        , tx2_1(35, 10,32,26, 4,(16,3), (20,1),22, 36)
        , add_ip(16,20,[2])
        , srp0(2)
        , mdrpg(18)
        , mdrpg(19)
        , ix()
        , dh1(13)
        , dh2(7)
        #y
        , sy()
        , mdap(1)
        , alignrp(3)
        , tvtpo(22)
        , tvtc2(13,[2,17,18,19])
        , head2(5,[23,29])
        , ud1(2)
        , ud2(17)
        , srp0(17)
        , alignrp(20)
        , iy()
        , dh1(10)
        ),

    'uni0E20':    #PHO SAMPHAO
        packline(""
        , tx2_1(50, 20,47,41, 25,13, 1,37, 51)
        , th_ko_kai(25,30,29,8,9)
        , add_ip(30,37,[34,5])
        , ix()
        , dh1(23)
        , dh2(17)
        #y
        , sy()
        , mdap(1)
        , tvtc2(34,[26,29,30,31,8,9,10,13,2,37])
        , tstemt_2(5)
        , srp0(1)
        , tvbc(17)
        , head1(25,[38,44])
        , iy()
        , dh1(20)
        ),

    'uni0E21':      #MO MA
        packline(""
        , tx2_1(58, (20,9),(43,55),(37,49), 14,(26,3), (29,1),31, 59)
        , ix()
        , dh1(23,12)
        , dh2(17,6)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(29)
        , tvt2(31)
        , tvtc2(23)
        , head2(15,[34,40])
        , srp0(1)
        , tvbc(6)
#        , head1(14,[44,50,27,3])
, 'SROUND 3', mdrpmrg(46)
, 'SROUND 69', mdrp0rg(14)
, f_ip([3,27])
, 'SROUND 3', headstem_2(52), 'RTG'
        , iy()
        , dh1(20,9)
        , ud1(3)
        ),
    
    'uni0E22':    #YO YAK
        packline(""
        , tx2_0(49, 3,28, 32,34, 50)
        , srp0(3)
        , mdrprg(25)
        , f_ip([7])
        , mdrp0rg(10)
        , tstemw_1(21)
        , ip_round(28,32,16)
        , xhead0(40,46,direction='-')
        , ud1(7)
        , ix()
        , dh1(13)
        , dh2(19)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(29)
        , tvt2(34)
        , tvtc2(13)
        , head2(19,[37,43,21])
        , ip_round(21,29,24)
        , tstemt_2(25)
        , f_ip([7])
        , iy()
        , f_dstr(21,"16+6 ")
        , dh2(16)
        ),

    'uni0E23':    #RO RUA
        packline(""
        , tx2_0(53, 12,34, 8,37, 54, fstem='tstemwc',rround=70)
        , srp0(8)
        , xhead1(3,50,44)
        , srp0(54)
        , mdrpmrw(24)
        , add_ip(12,24,[16,31,26,21])
        , ud2(34)
        , ix() 
        , dh1(6)
        , dh11(1), dh12(40)
        #y
        , sy() 
        , mdap(53)
        , v_top_ro_rua(16,[12,13,34,35,9,37], 31, 26,21, 23,24)
        , srp0(35)
        , tstemt_2(11)
        , srp0(53)
        , tvbc(0)
        , head1(8,[41,47])
        , iy()
        , dh1(3)
        ),  

    'uni0E24':      #RU
        packline(""
        , tx2_2(50, 25,13, 19,41,47, 1,37, 51)
        , th_ko_kai(25, 30,29, 8,9, s0=50)
        , add_ip(30,37,[34,5])
        , ix()
        #y
        , sy()
        , mdap(50)
        , tvtc2(34,[26,29,30,31, 8,9,10,13, 2,37])
        , tstemt_2(5)
        , srp0(50)
        , tvbc(22)
        , head1(14,[38,44])
        , srp0(50)
        , tvblu(1)
        , iy()
        , dh2(19)
        ),

    'uni0E25':      #LO LING
        packline(""
        , tx2_2p(53, 19,7, 13,44,50, (1,26),40, 54)
        , add_ip(53,19,[33])
        , add_ip(19,26,[23,5])
        , add_ip(33,40,[37,30])
        , ix()
        , dh1(10)
        , dh2(16)
        #y
        , sy()
        , mdap(1)
        , tvtc2(37,[20,7,27,40,26,23,33])
        , tstemt_2(30)
        , mdapr(33)
        , mdapr(23)
        , tstemt_2(4)
        , srp0(1)
        , tvbc(16)
        , head1(8,[41,47])
        , ud2(26)
        , iy()
        , dh2(13)
        ),

    'uni0E26':    #LU
        packline(""
        , tx2_1(50, 20,47,41, 25,13, 1,37, 51)
        , th_ko_kai(25,30,29,8,9)
        , add_ip(30,37,[34,5])
        , ix()
        , dh1(23)
        , dh2(17)
        #y
        , sy()
        , mdap(50)
        , tvtc2(34,[26,29,30,31, 8,9,10,13, 2,37])
        , tstemt_2(5)
        , srp0(50)
        , tvbc(17)
        , head1(25,[38,44])
        , srp0(50)
        , tvblu(1)
        , iy()
        , dh1(20)
        ),

    'uni0E27':    #WO WAEN
        packline(""
        , tx1_0(38, 15, 8,22, 39)
        , srp0(8)
        , xhead1(3,35,29)
        , add_ip(15,22,[19,12])
        , ix()
        , dh1(6)
        , dh11(1), dh12(25)
        #y
        , sy()
        , mdap(38)
        , tvtc2(19,[9,22,15])
        , tstemt_2(12)
        , mdapr(15)
        , srp0(38)
        , tvbc(0)
        , head1(8,[26,32])
        , iy()
        , dh1(3)
        ),  

    'uni0E28':    #SO SALA
        packline(""
        , tx2_0(66, 41,14, 1,53, 67)
        , th_kho_khwai(41, 35,34,17, 20,26,[63,57,31], 1)
        , add_ip(41,53,[44,11,9,46,51,4])
        , dx(9,8)
        , dx(51,-8)
        , ix()
        , dh1(23)
        , dh2(29)
        #y
        , sy()
        , mdap(1)
        , alignrp(34)
        , v_top_kho_khwai(44,[41,14,2,53,9,46,51,4,17], 11, 23,29,[54,60,31,20],add1=mdrpmrg(48))
        , dx(17,-16)
        , dx(4,8)
        , dx(46,-8)
        , iy()
        , dh2(26)
        , ud1(4)
        , ud2(46)
        ),

    'uni0E29':      #SO RUSI
        packline(""
        , tx2_1(66, 7,51,45, 1,(13,40), (33,22),(24,28), 67)
        , srp0(22)
        , mdrp0mrw(21)
        , mdrprg(63)
        , f_ip([57])
        , ix()
        , dh1(10,18)
        , dh2(2)
        #y  
        , sy()
        , mdap(1)
        , tstemt_1(41)
        , tvt2(24)
        , tvtc2(10,[18])
        , head2(2,[42,48])
        , mdapr(18)
        , mdrp0rg(37)
        , f_ip([54,60,14,40,21,22,34,25,28])
        , dx(34,8)
        , dx(25,-8)
        , dx(40,8)
        , dx(14,-8)
        , f_dstr_dict({40:"16+6 ",14:"16-6 "})
        , iy()
        , dh1(7)
        ),

    'uni0E2A':      #SO SUA
        packline(""
        , tx2_2p(65, 19,7, 13,56,62, (26,1),52, 66)
        , add_ip(65,19,[39])
        , add_ip(19,26,[23,4])
        , add_ip(39,52,[43,36,34,45,50,29])
        , dx(34,8)
        , dx(50,-8)
        , ix()
        , dh1(10)
        , dh2(16)
        #y
        , sy()
        , mdap(1)
        , tvtc2(43,[20,7,27,52,45,34,50,29,26,39,23])
        , mdrpmrg(47)
        , tstemt_2(36)
        , mdapr(39)
        , mdapr(23)
        , tstemt_2(4)
        , srp0(1)
        , tvbc(16)
        , head1(8,[53,59])
        , dx(29,8)
        , dx(45,-8)
        , ud2(26)
        , iy()
        , dh2(13)
        , ud1(29)
        , ud2(45)
        ),

    'uni0E2B':      #HO HIP
        packline(""
        , tx2_1(62, 14,47,41, 8,(20,7), 1,37, 63)
        , add_ip(20,1,[6])
        , srp0(6)
        , mdrpg(23) 
        , srp0(37)
#ROUNDED STEM
        , mdrp0rg(33)
#UNROUNDED STEM
#        , 'SROUND 70', mdapr(34), 'RTG'
        , 'SROUND 3', mdrpmrg(53), 'RTG'
        , mdrp0rg(27,"11-4 12-4 13-4 ")
        , 'SROUND 3', mdrpmrg(59), 'RTG'
        , ix()
        , dh1(18,31)
        , dh2(12)
        #y
        , sy()
        , mdap(1)
        , alignrp(8)
        , tvtc2(18,[22,24,6,2,38])
        , alignrp(31)
        , head2(10,[(39,51),(45,57)])
        , srp0(51)
        , tstemt_2(4)
        , f_ip([26,36])
        , ud2(22)
        , iy()
        , dh1(15,28)
        , dh2(34)
        ),

    'uni0E2C':      #LO CHULA
        packline(""
        , tx2_1(60, 10,45,39, 4,(16,3), (20,1),(35,32), 61)
        , srp0(20)
        , xhead1(26,57,51)
        , add_ip(16,20,[2])
        , srp0(2)
        , mdrpg(18)
        , mdrpg(19)
        , ix()
        , dh1(13,29)
        , dh2(7,23)
        #y
        , sy()
        , mdap(1)
        , alignrp(3)
        , tvtc2(13,[17])
        , head2(5,[36,42])
        , srp0(13)
        , mdrp0mrg(29)
        , head2(21,[48,54,35,32])
        , add_ip(21,1,[18,2])
        , ud1(2)
        , ud2(17)
        , srp0(17)
        , alignrp(20)
        , iy()
        , dh1(10,26)
        ),

    'uni0E2D':      #O ANG
        packline(""
        , tx2_2p(48, 3,15, 10,39,45, 19,33, 49)
        , ip_round(48,3,26)
        , add_ip(26,33,[30,23])
        , ix()
        , dh1(7)
        , dh2(15)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(16)
        , tvtc2(30,[20,33,7])
        , tstemt_2(23)
        , mdapr(7)
        , head2(15,[36,42])
        , ip_round(30,7,26)
        , iy()
        , dh2(10)
        ),  

    'uni0E2E':      #HO NOKHUK
        packline(""
        , tx2_2p(62, 3,15, 10,43,49, 19,37, 63)
        , srp0(3)
        , mdrp0rg(27)
        , tstemtc_1(59)
        , add_ip(27,37,[30,56,52,24, 54,32,35,22])
        , ud1(54)
        , ud2(35)
        , ix()
        , dh1(7)
        , dh2(15)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(16)
        , tvtc2(30,[20,37])
        , tstemt_2m(56)
        , mdrp0mrw(52,"9+8 10+8 ")
        , 'RTDG'
        , sarastemt_2m(24)
        , 'RTG'
        , mdrp0mrw(7)
        , mdapr(7)
        , head2(15,[40,46])
        , add_ip(30,52,[54,32,35,22])
        , dx(22,8)
        , dx(32,-8)
        , iy()
        , dh2(10)
        ),

    'uni0E2F':      #PAIYAN NOI
        packline(""
        , tx1_0(39, 11, (1,25),26, 40)
        , head1(17,[36,30,20])
        , ix()  
        , dh1(14)
        #y  
        , sy()
        , mdap(1)
        , tvt2(25)
        , tvtc2(14,[2])
        , head2(8,[27,33,20])
        , mdrp0rg(5)
        , tstemt_1(22)
        , ud1(2)
        , iy()
        , dh2(17)
        ),  

    'uni0E30':      #SARA A
        packline(""
        , srp0(66)
        , 'SROUND 71' , mdrp0rw(6) , 'RTG'
        , alignrp(39)
        , head1((12,45),[(30,63),(24,57),14,47])
        , mdapr(67)
        , mdrp0mrw(18)
        , alignrp(51)
        , ix()
        , dh1(42,9)
        , ud1(15)
        , srp0(15)
        , alignrp(48)
        #y  
        , sy()
        , mdapr(0)
        , tstemt_1(14)
        , mdrp0rg(3,"9+8 15-8 ")
        , head1(9,[21,27])
        , mdrprg(17)
        #
        , mdapr(33)
        , tstemt_1(47)
        , mdrp0rg(36,"9+8 15-8 ")
        , head1(42,[54,60])
        , mdrprg(50)
        , iy()
        , dh1(6,39)
        , dh2(12,45)
        ),

    'uni0E31':      #MAI HAN-AKAT
        packline(""
        , mdapr(12)
        , mdrprg(18)
        , head2(6,[30,24])
        , ix()
        , dh1(9)
        #y  
        , sy()
        , tvtsara(0)
        , tstemt_1(14)
        , mdrp0rg(3,"9+8 15-8 16-8 ")
        , head1(9,[21,27])
        , mdrprg(17)
        , iy()
        , dh1(6)
        , dh2(12)
        ),

    'uni0E32':    #SARA AA
        packline(""
        , tx1_0(16, 8, 1,15, 17)
        , add_ip(8,15,[12,5])
        , ix()
        #y
        , sy()
        , mdap(1)
        , tvtc2(12,[8,2,15])
        , tstemt_2(5)
        , mdapr(8)
        , iy()
        ),  

    'uni0E34':    #SARA I
        packline(""
        , thbsara(0)
        , tstemtc_2(11)
        , mdrp0rg(3)
        , tstemt_1(17)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , 'RTDG',mdrp0rg(17),'RTG'
        , f_ip([3,4,10,11])
        , mdrp0mrw(14)
        , mdapr(14)
        , sarastemw_1(7)
        , iy()
        ),
    
    'uni0E35':    #SARA II
        packline(""
        , thbsara(0)
        , alignrp(13)
        , dx(13,-8)
        , tstemt_2(11)
        , tstemtc_2(15)
        , mdrp0rg(3)
        , tstemt_1(21)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , 'RTDG',mdrp0rg(21),'RTG'
        , f_ip([3,4,13,14,15])
        , mdrp0mrw(18)
        , mdapr(18)
        , sarastemw_1m(7)
        , f_ip([10])
        , mdrpmrg(12)
        , ud2(10)
        , iy()
        ),
    
    'uni0E36':    #SARA UE
        packline(""
        , thbsara(0)
        , alignrp(18)
        , tstemtc_2(21)
        , mdrp0mrg(15)
        , head2(9,[39,33])
        , srp0(0)
        , mdrp0rg(3)
        , tstemt_1(27)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , 'RTDG',mdrp0rg(27),'RTG'
        , f_ip([3,4,21,18,20])
        , mdrp0mrw(24)
        , mdapr(24)
        , sarastemw_1m(7)
        , f_ip([9])
        , mdrp0rw(12)
        , head2(19,[30,36,18])
        , ud2(9)
        , iy()
        ),

    'uni0E37':    #SARA UUE
        packline(""
        , thbsara(0)
        , alignrp(15)
        , tstemtc_2(17)
        , sarastemw_2m(13)
        , mdrp0mrw(10)
        , sarastemw_2(8)
        , srp0(0)
        , mdrp0rg(3)
        , tstemt_1(23)
        , dx(15,-8)
        , dx(10,-8)
        , ix()
        #y  
        , sy()   
        , tvtsara(0)
        , 'RTDG',mdrp0rg(23),'RTG'
        , f_ip([3,4,15,16,17])
        , mdrp0mrw(20)
        , mdapr(20)
        , sarastemw_1m(7)
        , f_ip([10,12])
        , mdrpmrw(9)
        , shprp2(14)
        , ud2(12)
        , iy()
        ),  

    'uni0E38':    #SARA U
        packline(""
        , thbsara(13)
        , tstemtc_2(1)
        , mdrpmrg(7)
        , f_ip([23,17])
        , ix()
        #y  
        , sy()
        , mdap(26) 
        , mdrp0mrw(10)
        , head_sara_2m(4)
        , f_ip([14,20])
        , mdrpmrg(1)
        , iy()
        ),  

    'uni0E39':    #SARA UU
        packline(""
        , thbsara(17)
        , tstemt_2m(15)
        , mdrp0mrw(13)
#URS        , mdapr(13)
        , tstemt_2(1)
        , mdrpmrg(7)
        , f_ip([27,21])
        , ix() 
        #y  
        , sy()
        , mdap(30)
        , mdrp0mrw(10)
        , mdrprg(17)
        , mdrp0rg(4)
        , alignrp(14)
        , f_ip([24,18])
        , sarastemt_2(1)
        , iy()
        ),

    'uni0E3A':    #PHINTHU
        packline(""
        , thbsara(9)
        , mdrpmrg(3)
        , ix() 
        #y  
        , sy()
        , mdap(12)
        , mdrp0mrw(6)
        , mdrpmrg(0)
        , iy() 
        ),

    'uni0E3F':    #THAI CURRENCY SYMBOL BAHT
        packline(""
        , tx2_0(43, 3,(23,34), 28,17, 44, rround=68 )
        , srp0(28)
        , mdrp0g(39)
        , tstemw_1(11)
        , iprs_middle_stem(23, (21,1,32,5),'wanstemt',(31,20,42,7), 39)
        , ix()
        #y  
        , sy()
        , mdapr(2)
        , alignrp(20)
        , mdrpmrg(1)
        , tstemt_1(21)
        , shprp2(25)
        , mdapr(5)
        , alignrp(8)
        , mdrpmrg(6)
        , tstemt_2(33)
        , shprp2(42)
        , iprs_middle_stem(5, (32,36),'tstemt',(22,31), 21)
        , f_ip([14])
        , iy()
        ),

    'uni0E40':    #SARA E
        packline(""
        , trs_e(3,5, 11, 27)
        , xhead2(11,17,23)
        , ix()
        , dh1(8)
        , dh11(1), dh12(13)
        #y  
        , sy()
        , mdap(26)
        , tvt2(5)
        , tvbc(0)
        , head1(6,[14,20])
        , iy()
        , dh2(11)
        ),

    'uni0E42':    #SARA O
        packline(""
        , mdapr(7)
        , tstemtc_1(29)
        , mdapr(54)
        , mdrprw(19)
        , trs_e(3,32, 38, 54)
        , xhead2(38,44,50)
        , add_ip(7,19,[11,26,16,21])
        , ud2(29)
        , ix()
        , dh1(35)
        , dh11(1), dh12(40)
        #y  
        , sy()
        , mdap(53)
        , tvbc(0)
        , head1(33,[41,47])
        #
        , mdap(11)
        , tstemt_2(26)
        , 'RTDG'
        , mdrp0rg(21)
        , 'RTG'
        , tstemt_1(16)
        , srp0(11)
        , mdrp0rg(18)
        , tstemt_2(19)
        , add_ip(11,0,[4,7,8,29,30,32])
        , srp0(30)
        , tstemt_2(6)
        , iy()   
        , dh2(39)
        ),

    'uni0E43':    #SARA AI MAI MUAN
        packline(""
        , trs_e(3,34, 40, 68)
        , xhead2(40,46,52)
        , mdapr(23)
        , 'RTDG',sarastemt_1(64),'RTG'
        , mdrp0rg(17)
        , f_ip([14])
        , 'RTDG',sarastemt_2(58),'RTG'
        , mdrp0mrw(9)
        , mdrpb(29)
        , ix()
        , dh1(37)
        , dh2(20)
        , dh11(1), dh12(42)
        #y  
        , sy()
        , mdap(67)
        , tvbc(0) 
        , head1(35,[43,49])
        #
        , mdapr(26)
        , tstemtc_2(14)
        , 'SROUND 2',mdrprg(61)
        , 'SROUND 70', mdrp0rg(20)
        , 'RTDG',sarastemt_1(55),'RTG'
        , iy()
        , dh2(17,40)
        ),

    'uni0E44':    #SARA AI MAIMALAI
        packline(""
        , trs_e(3,19, 25, 41)
        , xhead2(25,31,37)
        , srp0(40)
        , mdrprg(11)
        , add_ip(11,3,[12,15,8,7])
        , ix()
        , dh1(22)
        , dh11(1), dh12(27)
        #y  
        , sy()
        , mdap(40)
        , tvbc(0)
        , head1(20,[28,34])
        #
        , mdap(19)
        , tstemtc_2(4)
        , mdrprg(12)
        , mdrp0rg(7)
        , f_ip([15])
        , ud2(15)
        , iy()
        , dh2(25)
        ),

    'uni0E45':    #LAKKHANGYAO
        packline(""
        , tx1(1,15, 17)
        , mdapr(8)
        , add_ip(8,15,[12,5])
        , ix()
        #y
        , sy()
        , mdap(16)
        , tvtc2(12,[8,2,15])
        , tstemt_2(5)
        , mdapr(8)
        , srp0(16)
        , tvblu(1)
        , iy()
        ),

    'uni0E46':    #MAIYAMOK
        packline(""
        , tx2_0(38, 19,8, 1,25, 39, fstem='tstemtc')
        , head1(13,[35,29])
        , add_ip(19,25,[21,22,23,4,5,6])
        , ix()
        , dh1(10)
        , dh2(16)
        #y
        , sy()
        , mdap(38)
        , tvtc2(21,[2,25])
        , alignrp(23)
        , tstemtc_2(6)
        , f_dstr(6,"14-4 15-8 ")
        , shprp2(4)
        , 'RUTG', mdrp0rg(5), 'RTG'
        , tstemt_1(22)
        , f_dstr(22,"14+4 15+4 ")
        , mdrp0rg(8)
        , mdapr(8)
        , head2(16,[26,32])
        #
        , srp0(38)
        , tvblu(1)
        , iy()
        , dh2(13)
        ),

    'uni0E47':    #MAITAIKHU
        packline(""
        , mdap(43)
        , mdrprg(18)
        , 'RTDG',mdrprg(32),'RTG'
        , f_ip([55,49])
        , mdrp0rg(11)
        , f_ip([27,30,5,8])
        , sarastemw_1(24)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , alignrp(8)
        , sarastemt_1(27)
        , 'RTDG',mdrprg(40),'RTG'
        , f_ip([46,52,30,5,35])
        , mdrp0mrg(21)
        , sarastemt_1m(15)
        , mdrpmrg(17)
        , iy()
        ),

    'uni0E47.high':    #MAITAIKHU
        packline(""
        , mdap(43)
        , mdrprg(18)
        , 'RTDG',mdrprg(37),'RTG'
        , f_ip([55,49])
        , mdrp0rg(11)
        , f_ip([27,30,5,3])
        , mdrpg(24)
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , alignrp(8)
        , mdrpg(27)
        , 'RTDG',mdrprg(40),'RTG'
        , f_ip([46,52,35,5,27])
        , mdrp0mrg(20)
        , mdrp0mg(15)
        , mdrpmrg(17)
        , iy()
        ),

    'uni0E48':    #MAI EK
        packline(""
        , mdap(0)
        , wanstemw_2(1)
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , mdrpg(3)
        , iy()
        ),

    'uni0E48.low':    #MAI EK
        packline(""
        , thbsara(0)
        , sarastemw_2(1)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , mdrpmg(3)
        , iy()
        ),

    'uni0E49':    #MAI THO
        packline(""
        , mdap(12)
        , mdrprg(18)
        , mdrprg(6)
        , f_ip([30,24,1,3,14])
        , ix()
        , dx(15,16)
        #y
        , sy()
        , tvtwanayuk(0)
        , mdrp0rg(3)
        , f_ip([1,15])
        , mdrp0rg(9)
        , f_ip([21,27])
        , mdrprg(17)
        , iy()
        ),

    'uni0E49.low':    #MAI THO
        packline(""
        , mdapr(12)
        , mdrprg(18)
        , 'RTDG',mdrp0rg(6),'RTG',f_ip([30,24,3,14])
        , mdrprg(0)
        , ix()
        , ud1(15)
        , dh1(9)
        #y
        , sy()
        , tvtsara(0)
        , sarastemt_1(1)
        , shprp2(14)
        , mdrp0rg(3)
        , 'RTDG',mdrp0rg(9),'RTG',f_ip([21,27])
        , mdrprg(17)
        , iy()
        , dh1(6)
        , dh2(12)
        ),

    'uni0E4A':    #MAI TRI
        packline(""
        , mdap(28)
        , mdrpg(3)
        , mdrprg(34)
        , mdrp0rg(20)
        , f_ip([23,24,25,5,6,7])
        , mdrpg(9)
        , 'RTDG',mdrprg(14),'RTG'
        , f_ip([46,40])
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , alignrp(17)
        , mdrpg(38)
        , shprp2(1)
        , 'RTDG',mdrprg(11),'RTG'
        , f_ip([37,43])
        , mdrp0rg(25)
        , alignrp(23)
        , mdrprg(33)
        , mdrpg(5)
        , shprp2(7)
        , iy()
        , dx(24,-16)
        ),

    'uni0E4A.low':    #MAI TRI
        packline(""
        , mdap(28)
        , tstemt_2(3)
        , mdrprg(34)
        , mdrp0rg(20)
        , f_ip([23,24,25,5,6,7])
        , tstemt_1(9)
        , 'RTDG',mdrp0rg(14),'RTG'
        , f_ip([46,40])
        , ix()
        , dh1(12)
        , dh2(18)
        #y
        , sy()
        , tvtsara(0)
        , alignrp(17)
        , sarastemt_1(30)
        , 'RTDG',mdrprg(11),'RTG'
        , f_ip([43,37])
        , mdrp0rg(25)
        , alignrp(23)
        , mdrprg(33)
        , sarastemt_2(5)
        , shprp2(7)
        , iy()
        , dh1(21)
        , dh2(15)
        , dx(24,-16)
        ),

    'uni0E4B':    #MAI CHATTAWA
       packline(""
        , mdapr(10)
        , mdrp0mrg(0)
        , alignrp(7)
        , mdrpg(10)
        , 'SROUND 4',mdrp0mrg(1),'RTG'
        , alignrp(6)
        , mdrpg(3)
        , ix()
        #y  
        , sy()
        , tvtwanayuk(0)
        , mdrp0mrg(10)
        , alignrp(3)
        , mdrpg(0)
        , 'SROUND 4',mdrp0mrg(9),'RTG'
        , alignrp(4)
        , mdrpg(7)
        , iy()
        ),

    'uni0E4B.low':    #MAI CHATTAWA
        packline(""
        , thbsara(10)
        , mdrp0mrg(0)
        , alignrp(7)
        , mdrpg(10)
        , 'SROUND 4',tstemt_2m(1),'RTG'
        , alignrp(6)
        , mdrpg(3)
        , ix()
        #y  
        , sy()
        , tvtsara(0)
        , mdrp0mrg(10)
        , alignrp(3)
        , mdrpg(0)
        , 'SROUND 4',tstemt_1m(9),'RTG'
        , alignrp(4)
        , mdrpg(7)
        , iy()
        ),

    'uni0E4C':    #THANTHAKAT
        packline(""
        , mdap(15)
        , mdrprg(10)
        , mdrpmrg(3), f_ip([27,21])
        , ix()
        #y  
        , sy()
        , tvtwanayuk(0)
        , mdrp0mrg(6), f_ip([18,24])
        , mdrpmrg(9)
        , mdrpmg(12)
        , iy()
        ),

    'uni0E4C.low':    #THANTHAKAT
        packline(""
        , mdap(15)
        , mdrprg(10)
        , mdrpmrg(3), f_ip([27,21])
        , ix()
        #y  
        , sy()
        , tvtsara(0)
        , mdrp0mrg(6), f_ip([18,24])
        , mdrpmrg(9)
        , headstem_2(12)
        , iy()
        ),

    'uni0E4D':    #NIKHAHIT
        packline(""
        , mdap(9)
        , head2(3,[21,15])
        , f_dstr(3,"9-8 ")
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , head1(6,[12,18])
        , f_dstr(6,"9+8 ")
        , iy()
        ),

    'uni0E4D.high':    #NIKHAHIT
        packline(""
        , mdap(9)
        , mdrprg(3)
        , f_ip([21,15])
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , mdrprg(6)
        , f_ip([12,18])
        , iy()
        ),

    'uni0E4E':    #YAMAKKAN
        packline(""
        , thbsara(16)
        , mdrp0rg(10)
        , f_ip([26,0,7])
        , wanstemw_1(21)
        , mdrp0rg(4)
        , wanstemw_1(30)
        , ix()
        #
        , sy()
        , tvtsara(0)
        , wanstemt_1(33)
        , mdrp0rg(13)
        , f_ip([24])
        , wanstemt_2(18)
        , mdapr(24)
        , wanstemt_2(27)
        , f_ip([7])
        , iy()
        ),

    'uni0E4F':    #FONGMAN
        packline(""
        , mdapr(49) 
        , mdrp0mrw(9)
        , wanstemw_2m(15)
        , mdrpmrw(33)
        , srp0(9)
        , mdrp0rg(3)
        , wanstemw_1m(21)
        , mdrpmrw(27)
        , add_ip(27,33,[45,39])
        , ix()
        #y  
        , sy()
        , mdapr(0) 
        , wanstemw_1m(12)
        , mdrpmrw(24)
        , srp0(0)
        , mdrp0rg(6)
        , wanstemw_2m(18)
        , mdrpmrw(30)
        , add_ip(30,24,[36,42])
        , iy()
        ),

    'uni0E50':    #THAI DIGIT ZERO
        packline(""
        , tx2_0(24, 3,21, 15,9, 25, fstem='tnumstemw',rstem='tnumstemw')
        , ix()
        #y  
        , sy()
        , mdap(24)
        , tvtnc(6)
        , tstemt_2(18)
        , srp0(24)
        , tvbc(0)
        , tstemt_1(12)
        , iy()
        ),

    'uni0E51':    #THAI DIGIT ONE
        packline(""
        , tx2_0(48, 3,22, 16,9, 49, fstem='tnumstemw',rstem='tnumstemw')
        , ip_round(3,16,27)
        , mdrpmrg(13)
        , head1(33,[45,39])
        , ix()
        , dh1(30)
        #y  
        , sy()
        , mdapr(0)
        , mdrp0rg(13)
        , tstemt_2(12)
        , tvtnc(6,[3,22,16,9])
        , tstemtc_2(19)
        , srp0(0)
        , tstemtc_1(25)
        , ip_round(19,0,30)
        , xhead0(42,36,direction='-')
        , iy()
        , dh1(27)
        , dh2(33)
        ),

    'uni0E52':    #THAI DIGIT TWO
        packline(""
        , tx2_0(49, 3,8, 13,35, 50, fstem='tnumstemw',rstem='tnumstemw')
        , ip_round(8,13,29)
        , tstemw_1(18)
        , mdrp0rg(27)
        , head1(22,[46,40])
        , add_ip(29,35,[31,32,33,15,16,17])
        , ix()
        , dh1(18)
        , dh2(25)
        #y  
        , sy()
        , mdap(0)
        , tstemt_1(11)
        , tvtnc(33)
        , alignrp(31)
        , mdrpmrg(6)
        , tstemt_2(15)
        , shprp2(17)
        , 'RUTG' , mdrp0mrg(16), 'RTG'
        , mdrpb(32)
        , srp0(11)
        , mdrp0mrw(25)
        , head1(18,[37,43])
        , iy()
        , dh2(22)
        ),

    'uni0E53':    #THAI DIGIT THREE
        packline(""
        , tx3_0(55, 29,14, 9,7, 3,41, 56, fstem='tnumstemw',mstem='tnumstemw',rstem='tnumstemw')
        , srp0(29)
        , xhead2(20,46,52,dstr="")
        , add_ip(9,7,[35])
        , ix()
        , dh1(17)
        , dh2(23)
        #y  
        , sy()
        , mdap(1)
        , tvtnc(38,[29,14,9,35,3,41])
        , alignrp(32)
        , tstemt_2(5)
        , shprp2(12)
        , srp0(1)
        , tvbc(23)
        , head1(17,[43,49])
        , iy()
        , dh2(20)
        ),

    'uni0E54':    #THAI DIGIT FOUR
        packline(""
        , tx1_1(54, 9,22, 0, 55, fstem='tnumstemw')
        , ip_round(8,0,30)
        , head1(36,[51,45,27,38,3])
        , ip_round(0,55,16)
        , ud1(27)
        , ix()
        , dh1(33)
        #y  
        , sy()
        , mdap(0)
        , tstemt_1(41)
        , tvtn(13,[9,22])
        , mdrprg(15)
        , tstemt_2m(18)
        , mdrp0mrw(33)
        , xhead0(48,42,direction='-')
        , mdrpg(27)
        , f_ip([38])
        , srp0(0)
        , tvbc(6)
        , tstemt_1(25)
        , iy()
        , dh1(30)
        , dh2(36)
        ),

    'uni0E55':    #THAI DIGIT FIVE
        packline(""
        , tx1_1(75, 9,31, 0, 76, fstem='tnumstemw')
        , ip_round(9,0,39)
        , head1(45,[60,54])
        , add_ip(39,45,[36,47,3])
        , srp0(39)
        , mdrp0rg(14)
        , head1(20,[72,66])
        , ip_round(0,76,25)
        , ud1(36)
        , ix()
        , dh1(42,17)
        #y  
        , sy()
        , mdap(0)
        , tstemt_1(50)
        , tvtn(22,[9,31])
        , alignrp(12)
        , mdrprg(24)
        , tstemt_2(27)
        , mdrp0rg(17)
        , xhead0(69,63,direction='-')
        , srp0(27)
        , mdrp0mrw(42)
        , xhead0(57,51,direction='-')
        , mdrpg(36)
        , f_ip([47])
        , srp0(0)
        , tvbc(6)
        , tstemt_1(34)
        , iy()
        , dh1(39)
        , dh2(45)
        ),

    'uni0E56':    #THAI DIGIT SIX
        packline(""
        , tx1(19,38, 54, rstem='tnumstemw')
        , ip_round(53,19,6)
        , head1(12,[50,44,14])
        , add_ip(53,44,[28,29,25,32])
        , ix()
        , dh1(9)
        #y  
        , sy()
        , mdap(53)
        , tvtnc(35,[19,38,25,32]) 
        , tstemt_2(22)
        , mdrp0rg(29)
        , tstemt_2(28)
        , srp0(53)
        , tvbc(0)
        , tstemt_1(16)
        , mdrp0rg(3)
        , head1(9,[41,47])
        , iy()
        , dh1(6)
        , dh2(12)
        ),

    'uni0E57':    #THAI DIGIT SEVEN
        packline(""
        , tx2_0(63, 26,14, 43,48, 64, fround=68, fstem='tnumstemw',rstem='tnumstemw')
        , iprs_middle_stem(26, 3,'tnumstemw',38, 43, mround=70, dsm="17-8 ")
        , iprs_middle_stem(26, 9,'tnumstemw',7, 3, mround=72)
        , f_ip([32])
        , srp0(26)
        , xhead2(20,54,60, dstr="")
        , add_ip(26,9,[29,12])
        , add_ip(7,38,[35,5])
        , ix()
        , dh1(17)
        , dh2(23)
        #y  
        , sy()
        , mdap(1)
        , tstemt_1(40)
        , tvtnc(35,[26,14,32,9,3,38,43,46])
        , alignrp(29)
        , mdrprg(45)
        , tstemt_2(5)
        , shprp2(12)
        , srp0(1)
        , tvbc(23)
        , head1(17,[51,57])
        , iy()
        , dh2(20)
        ),

    'uni0E58':    #THAI DIGIT EIGHT
        packline(""
        , tx1_1(55, 8,21, 37, 56, fstem='tnumstemw')
        , srp0(37)
        , head2(31,[52,46,29])
        , ip_round(21,31,24)
        , mdrpg(26)
        , f_ip([25,4,3])
        , ip_round(37,56,15)
        , ud1(29)
        , ix()  
        , dh1(34)
        #y  
        , sy()
        , mdap(0)
        , alignrp(4)
        , tstemt_1(29)
        , shprp2(24)
        , tvtn(12,[8,21])
        , mdrprg(14)
        , tstemt_2(17)
        , srp0(0)
        , mdrp0rg(34)
        , head2(40,[43,49])
        , srp0(0)
        , mdrp0rg(25)
        , tstemw_2(3)
        , iy()
        , dh1(31)
        ),

    'uni0E59':    #THAI DIGIT NINE
        packline(""
        , tx2_0(64, 24,7, 1,0, 65, fstem='tnumstemw',rstem='tnumstemw')
        , mdrp0rg(18)
        , head2(12,[61,55])
        , add_ip(7,1,[27,4,3,2,30,49])
        , add_ip(30,0,[33,46,43,36])
        , ip_round(0,65,40)
        , ix()  
        , dh1(15)
        #y  
        , sy()
        , mdap(1)
        , tvtnc(33,[24,7,2,49,30])
        , alignrp(27)
        , mdrprg(39)
        , tstemt_2(46)
        , shprp2(4)
        , mdrp0rg(43)
        , tstemt_1(36)
        , srp0(1)
        , tvbc(21)
        , head1(15,[52,58])
        , iy()
        , dh1(12)
        , dh2(18)
        ),

    'uni0E5A':      #ANGKHANKHU
        packline(""
        , tx1(39,41, 43)
        , srp0(39)
        , mdrp0mrw(25)
        , tstemw_2(1)
        , shprp2(24)
        , ip_round(42,1,11)
        , head1(17,[35,29])
        , ix()
        , dh1(14)
        #y  
        , sy()
        , mdapr(1)
        , alignrp(39)
        , tvt2(24,[2,25,40,41])
        , tvtc2(14)
        , head2(8,[26,32,19])
        , mdrp0rg(5)
        , tstemt_1(21)
        , iy()
        , dh2(17)
        ),

    'uni0E5B':      #KHOMUT
        packline(""
        , tx1_1(71, 3,26, 47, 72)
        , mdrp0mrw(15)
        , xhead0(68,62)
        , mdrp0rg(9)
        , tstemtc_2(20)
        , add_ip(9,47,[32,37,42,55,52,50])
        , ix()
        , dh1(18)
        , dh2(12)
        #y  
        , sy()
        , mdapr(6)
        , tstemt_2(24)
        , mdapr(71)
        , tvbc(0)
        , tstemt_1m(29)
        , mdrp0mrw(12) 
#        , mdapr(12)
        , head1(18,[59,65])
        , add_ip(23,29,[32,34,37,39,42,45,56,55,53,52,50])
        , mdapr(45)
        , tstemt_2(48)
        , iy()
        , dh1(15)
        ),

    }



#++++++++++++++++++++++++++++++

#----- MODIFY pseudo_code_dict BY -----------
#----- SUBSTITUTE FUNCTION IN TEXT FORM -----
#----- TO REAL pseudo_code ------------------
from dttcmd import *

self_func = []
for i in dir():
    if callable(eval(i)): self_func.append(i)

for i in pseudo_code_dict.keys():
    p_list = pseudo_code_dict[i].split('\n')
    for j in range(len(p_list)):
        if '(' in p_list[j]:
            if p_list[j].split('(',1)[0] in self_func:
                l = [n for n in range(len(p_list[j])) if p_list[j][n] == ')']
                t = p_list[j][:l[-1]+1]
                p_list[j] = p_list[j].rep_listace(t, eval(t))
    pseudo_code_dict[i] = '\n'.join(p_list)
